#!/usr/bin/perl -w
#
# Convert FILES.BBS to offline lists
# Copyright (C) 2000, Kostromitinov Pavel
#
use File::Basename;

die "Usage: BBS2Offl.pl Files.bbs [Files.offl]\n" unless (@ARGV==1)||(@ARGV==2);
open(INFILE,$ARGV[0]) or die "Cannot open $ARGV[0]: $!\n";
$OutFile=(defined $ARGV[1])?$ARGV[1]:$ARGV[0].'.off';
open(OUTFILE,">$OutFile") or die("Cannot create $OutFile: $!\n");

while (defined(my $Line=<INFILE>)) {
	chomp $Line;
	next if $Line=~/^\s*$/;
	if ($Line=~/^((".+")|(\S+))\s*(\[(\d+)\])?\s*(.*?)\s*$/) {
		my $QuotedName=$1;
		my $ListName=(defined($2))?substr($2,1,length($2)-2):$3;
		my $Counter=(defined $4)?$4:'';
		my $Description=$6;
		my $FullName=dirname($ARGV[0]).'/'.$ListName;
		my @Stat=stat($FullName);
		print OUTFILE $QuotedName,' ',$Stat[7],' ',ExpandDateTime($Stat[9]),' ',$Counter,' ',$Description,"\n";
	} else {
		print OUTFILE "$Line\n";
	}
}

close(INFILE);
close(OUTFILE);

sub ExpandDateTime {
	my $DT=shift;
	my ($Sec,$Min,$Hour,$Day,$Month,$Year)=localtime($DT);
	return sprintf(' %02d/%02d/%04d %02d:%02d:%02d',$Day,$Month+1,$Year+1900,$Hour,$Min,$Sec);
}
