#!/usr/bin/perl -w
#
# Convert binary file to offline lists
# Copyright (C) 2000, Kostromitinov Pavel
#
BEGIN {					# Hack to search for modules in current folder
	$0=~/^(.*)[\/\\:]/;
	push (@INC,$1) if (defined $1)&&($1 ne '');
}

use FNdxCommon;
use FNdxConfig;
BEGIN {do 'FNdxExport.pm';}

die("Usage: Bin2Offl.pl BinFile StoreDir/ [TagMask]") unless (@ARGV==2)||(@ARGV==3);
($BinFile,$StoreDir,$TagMask)=@ARGV;
$TagMask='.*' unless defined $TagMask;

open(BINFILE,$BinFile) or die("Cannot open '$BinFile': $!\n");
binmode BINFILE;
read BINFILE,$Check,4;
if ($Check eq 'FIDX') {
	read BINFILE,$Data,12;
	($BINVersion,undef,$Count)=unpack('VVV',$Data);
	if ($BINVersion<=$CurrentVersion) {
		for (my $I=0;$I<$Count;$I++) {push(@Areas,LoadBin FNdxArea(*BINFILE{IO}));}
	} else {
		print "Binary file '$BinFile' is of incompatible version\n";
	}
} else {print "Invalid binary file '$BinFile'\n";}

close(BINFILE);

foreach my $Area (@Areas) {
	next unless $Area->{'Tag'}=~/$TagMask/;
	my $FileName=$StoreDir.$Area->{'Tag'}.'.Off';
	open(OFFLINE,">$FileName") or die("Cannot create '$FileName': $!\n");
	foreach my $File (@{$Area->{'Files'}}) {
		print OFFLINE (($File->{'Name'}=~/\s/)?'"'.$File->{'Name'}.'"':$File->{'Name'});
		print OFFLINE ' ',$File->{'Size'},ExpandDateTime($File->{'Added'});
		printf OFFLINE ' [%03d]',$File->{'Counter'};
		foreach my $Descr (@{$File->{'Description'}}) {print OFFLINE " $Descr\n";}
	}
	close(OFFLINE);
}

sub ExpandDateTime {
	my $DT=shift;
	my ($Sec,$Min,$Hour,$Day,$Month,$Year)=localtime($DT);
	return sprintf(' %02d/%02d/%04d %02d:%02d:%02d',$Day,$Month+1,$Year+1900,$Hour,$Min,$Sec);
}
