# FileNdx 4.52 - binary file loading & saving
# Copyright (C) 2000, Kostromitinov Pavel
#
package FNdxBinary;
require Exporter;
use FNdxArea;
use FNdxCommon;
@ISA=qw(Exporter);
@EXPORT=qw(LoadBinaryFile SaveBinaryFile);

sub LoadBinaryFile {
	my ($FileName,$CurrentVersion,$BinAreas)=@_;
	local *BINFILE;
	unless (open(BINFILE,$FileName)) {
		print STDERR "Cannot open binary file '$FileName': $!\n";
		return (0,undef);
	}

	my ($Check,$Data,$Created,$Count,$IsValidBin);
    $IsValidBin=0;

	binmode BINFILE;
	read BINFILE,$Check,4;
	if ($Check ne 'FIDX') {
		print STDERR "Invalid binary file '$FileName'\n";
	} else {
		read BINFILE,$Data,12;
		($FNdxCommon::BINVersion,$Created,$Count)=unpack('VVV',$Data);
		if ($FNdxCommon::BINVersion<=$CurrentVersion) {
			my $Pos=tell(BINFILE);seek(BINFILE,0,2);
			my $Size=tell(BINFILE)-$Pos;seek(BINFILE,$Pos,0);
			read(BINFILE,$Data,$Size);

			for (my $I=0;$I<$Count;$I++) {push(@$BinAreas,LoadBin FNdxArea(\$Data));}
			$IsValidBin=1;
		} else {
			print STDERR "Binary file '$FileName' is of incompatible version\n";
		}
	}
	close(BINFILE);
	return ($IsValidBin,$Created);
}

sub SaveBinaryFile {
	my ($FileName,$CurrentVersion,$BinAreas)=@_;
	local *OUTPUT;

	unless (open(OUTPUT,">$FileName")) {
		print "Cannot open output file '$FileName': $!\n";
		return;
	}
	binmode OUTPUT;
	print OUTPUT 'FIDX',pack('VVV',$CurrentVersion,time(),scalar @$BinAreas);
	foreach my $Area (@$BinAreas) {
		$Area->SaveBin(*OUTPUT{IO});
	}
	close(OUTPUT);
}

1;
