# FileNdx 4.52 - Common variables and routines
# Copyright (C) 2000, Kostromitinov Pavel
#
package FNdxCommon;
require Exporter;
@ISA=qw(Exporter);
@EXPORT=qw(Size LoadTemplate Date PrintUserTemplate PrintUserTemplateFromFile
	ProcessUserVars ExpandUserString
	WhatSavingPrefix SaveString LoadString LoadBinString ProcessPath);
use Carp;
use PKFormat;

%SwitchParams=(
	'G'=>-1,
	'T'=>0,
	'V'=>0,
	'H'=>0
);

%StringParams=(
	'C'=>'',
	'I'=>[],
	'S'=>[],
	'D'=>[]
);

%Templates=(
	'AreaStart'=>[],
	'AreaEnd'=>[],
	'SubAreaStart'=>[],
	'SubAreaEnd'=>[],
	'OfflineAreaStart'=>[],
	'OfflineAreaEnd'=>[]
);

$CurrentVersion=450;
$BINVersion=$CurrentVersion;

%Config=(
#Booleans
	'SmartListUpdate'		=> 1,
	'DeleteNonExisting'		=> 1,
	'IncludeEmpty'			=> 0,
	'UseMLChar'				=> 0,
	'LogAnalyzer'			=> 1,
	'AddCopyright'			=> 1,
	'Verbose'				=> 0,
	'MarkNewFiles'			=> 1,
#Numbers
	'LDescStart'			=> 14,
	'WaitInput'				=> 0,			#UNUSED
	'DescWidth'				=> [40,40,42],
	'ListFileCounter'		=> 3,
	'NewFileDays'			=> 7,
	'BestFiles'				=> 16,
	'MaxSFNLength'			=> 12,
	'DefaultAccessLevel'	=> 0,
	'Limit1'				=> 1024,
	'Limit2'				=> 1048576,
#Existing Files
	'Header'				=> 'HEADER.TPL',
	'Footer'				=> 'FOOTER.TPL',
	'NewHeader'				=> 'HEAD_NEW.TPL',
	'NewFooter'				=> 'FOOT_NEW.TPL',
	'BestHeader'			=> 'HEAD_BST.TPL',
	'BestFooter'			=> 'FOOT_BST.TPL',
	'AreaStart'				=> 'START.TPL',
	'SubAreaStart'			=> 'SUBSTART.TPL',
	'OfflineAreaStart'		=> 'OFFSTART.TPL',
	'AreaEnd'				=> 'END.TPL',
	'SubAreaEnd'			=> 'SUBEND.TPL',
	'OfflineAreaStart'		=> 'OFFEND.TPL',
	'AreaListStart'			=> 'ALSTART.TPL',
	'AreaListItems'			=> [' %>2N %<8T %D %<62.%>3F  %>8Z  ',
								' >%>2N %<8T %D %<62.%>3F  %>8Z  ',
								' %>2N %<8T %D %<52.(Offline) %>3F  %>8Z  '],
	'AreaListEnd'			=> 'ALEND.TPL',
	'NewAreaListStart'		=> 'NALSTART.TPL',
	'NewAreaListItems'		=> [' %>2N %<8T %D %<62.%>3F  %>8Z  ',
								' >%>2N %<8T %D %<62.%>3F  %>8Z  ',
								' %>2N %<8T %D %<52.(Offline) %>3F  %>8Z  '],
	'NewAreaListEnd'		=> 'NALEND.TPL',
#New Files
	'Output'				=> 'FILELIST.LST',
	'NewOutput'				=> 'FILELIST.NEW',
	'BestOutput'			=> 'FILELIST.BST',
	'BinOutput'				=> 'FILELIST.BIN',
	'LogBinary'				=> 'LOGS.BIN',
	'AreaFile'				=> '%T.LST',
	'NewAreaFile'			=> '%T.NEW',
	'Log'					=> '-',
#Strings
	'ListFile'				=> 'FILES.BBS',
	'NewMark'				=> '*',
	'NotNewMark'			=> ' ',
	'Tag1'					=> ' ',
	'Tag2'					=> 'K',
	'Tag3'					=> 'M',
	'DefaultDescription'	=> '--Description missing--',
	'ExcludeDescription'	=> '---',
#Formats
	'FileFormats'			=> ['%<12N %>7Z %T%I[%>3_0C] %<37.%D',
								'%<12N %>7Z %T%I[%>3_0C] %<37.%D',
								'%<2A %<8G => %<12N [%>3_0C]%<35.%D'],
	'FileFormatsCont'		=> ['%<37.%D',
								'%<37.%D',
								'%<35.%D'],
	'LFNFileFormats'		=> ['%N\%<13.%>7Z %T%I[%>3_0C] %<37.%D',
								'%N\%<13.%>7Z %T%I[%>3_0C] %<37.%D',
								'%<2A %<8G => %N\%<27.[%>3_0C]%<35.%D'],
	'LFNFileFormatsCont'	=> ['%<37.%D',
								'%<37.%D',
								'%<35.%D'],
	'DateFormat'			=> '%>2_0D/%>2_0N/%>2_0R',
#Other
	'VersionStamp'			=> $CurrentVersion,
	'MLChar'				=> '>',
	'AddDirInfo'			=> 0,				# Combin. of Normal, New, Best
	'IncludeAreaList'		=> 1,				# No, Normal, New, All
	'MultipleFile'			=> 0,				# *
	'PromptForNew'			=> 1,				# No, Yes, Auto, Manual
	'WrapLong'				=> 2,				# No, Yes, [Single] Line
	'SFNCase'				=> 2,				# Preserve, Lower, Upper, Capital
	'LFNCase'				=> 0,				# *
#Lists
	'Areas'					=> [],
	'Exclude'				=> [],
	'Logs'					=> [],
	'LogStrings'			=> [],
	'Descriptor'			=> [],
	'AccessLevel'			=> [],
	'ExcludeFromNew'		=> [],
	'ExcludeFromBest'		=> [],
	'DirInfo'				=> [],
	'ProcessPath'			=> []
);

%UserVars=(
	'FileFormat'			=>	\$Config{'FileFormats'}->[0],
	'NewFileFormat'			=>	\$Config{'FileFormats'}->[1],
	'BestFileFormat'		=>	\$Config{'FileFormats'}->[2],
	'FileFormatCont'		=>	\$Config{'FileFormatsCont'}->[0],
	'NewFileFormatCont'		=>	\$Config{'FileFormatsCont'}->[1],
	'BestFileFormatCont'	=>	\$Config{'FileFormatsCont'}->[2],
	'LFNFileFormat'			=>	\$Config{'LFNFileFormats'}->[0],
	'LFNNewFileFormat'		=>	\$Config{'LFNFileFormats'}->[1],
	'LFNBestFileFormat'		=>	\$Config{'LFNFileFormats'}->[2],
	'LFNFileFormatCont'		=>	\$Config{'LFNFileFormatsCont'}->[0],
	'LFNNewFileFormatCont'	=>	\$Config{'LFNFileFormatsCont'}->[1],
	'LFNBestFileFormatCont'	=>	\$Config{'LFNFileFormatsCont'}->[2],

	'AreaListItem'			=>	\$Config{'AreaListItems'}->[0],
	'SubAreaListItem'		=>	\$Config{'AreaListItems'}->[1],
	'OfflineAreaListItem'	=>	\$Config{'AreaListItems'}->[2],
	'NewAreaListItem'		=>	\$Config{'NewAreaListItems'}->[0],
	'NewSubAreaListItem'	=>	\$Config{'NewAreaListItems'}->[1],
	'NewOfflineAreaListItem'=>	\$Config{'NewAreaListItems'}->[2],
);

$WhatSaving=0;
$LastNewTime=0;
$CurrentTime=time();
$IsValidBin=0;
*Debug=\$SwitchParams{'V'};
#	DIRTY way to create a filehandle glob entry
open(OUTPUT,'>-');close(OUTPUT);

sub Size {
	my $Size=$_[0];
	if ($Size<$Config{'Limit1'}) {return $Size.$Config{'Tag1'};}
	if ($Size<$Config{'Limit2'}) {return sprintf('%3.1f',$Size/0x400).$Config{'Tag2'};}
	return sprintf('%3.1f',$Size/0x100000).$Config{'Tag3'};
}

sub Date {
	return FormatDateTime($_[0],$Config{'DateFormat'});
}

sub LoadTemplate {
	my $Name=$_[0];
	my $FileName=$Config{$Name};
	local *TEMPLATE;
	open(TEMPLATE,$FileName) or croak "Cannot open file '$FileName': $!";
	@{$Templates{$Name}}=<TEMPLATE>;
	close(TEMPLATE);
	chomp @{$Templates{$Name}};
}

sub ProcessUserVars {
	my $String=shift;
	my $Result='';

	while ($String=~/^(.*?)(\\*)\$(\{(\w+)\}|\w+)(.*)$/) {
		$Result=$Result.$1.('\\'x(length($2)/2));
		if (length($2)&1==1) {		# Odd number of '\' - Do NOT substitute
			$Result=$Result.'$'.$3;
		} else {					# DO substitute;
			my $VarName=(defined $4)?$4:$3;
			if (exists $UserVars{$VarName}) {
				$Result.=UnRef($UserVars{$VarName});
			} elsif (exists $Config{$VarName}) {
				$Result.=UnRef($Config{$VarName});
			} elsif (exists $ENV{$VarName}) {
				$Result.=UnRef($ENV{$VarName});
			}
		}
		$String=$5;
	};
	return $Result.$String;
}

sub ExpandUserString {
	my ($String,$Params)=@_;
	return ExpandString(ProcessUserVars($String),$Params);
}

sub PrintUserTemplate {
	my ($FileRef,$Template,$Params)=@_;
	my $Lines=Template($Template,$Params);

	map {$_=ProcessUserVars($_)} @$Lines;

    foreach my $Line (@$Lines) {print $FileRef "$Line\n";}
}

sub PrintUserTemplateFromFile {
	my ($FileRef,$FileName,$Params)=@_;
	my $Lines=TemplateFromFile($FileName,$Params);
	die "Cannot open '$FileName': $!\n" unless defined $Lines;

	map {$_=ProcessUserVars($_)} @$Lines;

    foreach my $Line (@$Lines) {print $FileRef "$Line\n";}
}

sub WhatSavingPrefix {
	return '' if ($WhatSaving==0);
	return 'New' if ($WhatSaving==1);
	return 'Best' if ($WhatSaving==2);
	return 'Bin';
}

sub SaveString {
	my $FileRef=$_[0];
	if (ref $FileRef eq 'IO::Handle') {shift;} else {$FileRef=*OUTPUT{IO}};
	foreach my $String (@_) {
		print $FileRef pack('VA'.length($String),length($String),$String);
	}
}

sub LoadString {
	my $DataRef=shift;
	my ($Data,$Length,$String);
	($Length)=unpack('V',$$DataRef);
	$String=substr($$DataRef,4,$Length);
    substr($$DataRef,0,$Length+4,'');
	return $String;
}

sub LoadBinString {
	my $FileRef=shift;
	my ($Data,$Length,$String);
	read $FileRef,$Data,4;
	($Length)=unpack('V',$Data);
	read $FileRef,$String,$Length;
	return $String;
}

sub ProcessPath {
	my $Path=shift;
	foreach my $Process (@{$Config{'ProcessPath'}}) {
		eval "\$Path=~$Process;";
	}
	return $Path;
}

sub UnRef {
	my $Value=shift;
	return (ref $Value eq 'SCALAR')?$$Value:$Value;
}

1;
