# FileNdx 4.52 - Descriptor class
# Copyright (C) 2000, Kostromitinov Pavel
#
package FNdxDescriptor;
use FNdxCommon;
use PKFormat;

sub new {
	my ($Class,$Masks,$CommandLine,$File)=@_;
	croak('Invalid array ref passed') unless ref $Masks eq 'ARRAY';
	$Class=ref $Class if ref $Class;
	my %Descr=('Masks'=>$Masks,'CommandLine'=>$CommandLine,'File'=>$File);
	return bless \%Descr,$Class;
}

sub Applies {
	my ($This,$FileName)=@_;
	return IsFileMask($FileName,@{$This->{'Masks'}});
}

sub GetDescription {
	my ($This,$Path,$Name)=@_;
	my $CmdLine=$This->{'CommandLine'};
	my $File;

	$CmdLine=~s/%F/$Path$Name/gi;
	$CmdLine=~s/%P/$Path/gi;
	$CmdLine=~s/%N/$Name/gi;
	if (defined $This->{'File'}) {
		$File=$This->{'File'};
		$File=~s/%P/$Path/gi;
		system($CmdLine);
	} else {
		$File=$CmdLine.'|';
	}
	if (open(DESCFILE,$File)) {
		my @DescList=<DESCFILE>;
		chomp @DescList;
		close(DESCFILE);
		unlink $File if defined $This->{'File'};
		return \@DescList;
	} else {return undef;}
}

1;
