# FileNdx 4.52 - Logger class
# Copyright (C) 2000, Kostromitinov Pavel
#
package FNdxLogger;
use PKFormat;
use FNdxCommon;
BEGIN {do 'FNdxExport.pm';}

sub new {
	my ($Class,$UID,$File,$Pattern)=@_;
	$Class=ref $Class if ref $Class;
	my %Logger=('UID'=>$UID,'File'=>$File,'Pattern'=>$Pattern);
	return bless \%Logger,$Class;
}

sub Apply {
	my ($This,$Line,$Logging,$Logged)=@_;
	croak('Invalid first array ref passed') if ref($Logging) ne 'ARRAY';
	croak('Invalid second array ref passed') if ref($Logged) ne 'ARRAY';
	my $Pattern=$This->{'Pattern'};
	my @Res;
	undef @Res;
	@Res=($Line=~/$Pattern/);
	if (@Res) {
		@Res=($Res[$This->{'UID'}],$Res[$This->{'File'}]);
		return 1 if IsFileMask($Res[1],@{$Config{'Exclude'}});
		for my $File (@$Logging) {return 1 if $File->[0] eq $Res[0];}
		for my $File (@$Logged) {return 1 if $File->[0] eq $Res[0];}
		print STDERR 'File logged: ',$Res[1],"\n";
		push(@$Logging,\@Res);
		return 1;
	} else {return undef;}
}

sub LoadLogBin {
	my @Logged=();
	if (open(LOGBIN,$Config{'LogBinary'})) {
		binmode LOGBIN;
		my ($Data,$Count);
		read LOGBIN,$Data,4;
		($Count)=unpack('V',$Data);
		for (my $I=0;$I<$Count;$I++) {
			my $UID=LoadBinString(*LOGBIN{IO});
			my $File=LoadBinString(*LOGBIN{IO});
			push(@Logged,[$UID,$File]);
		}
		close(LOGBIN);
	} else {
		print STDERR "Cannot open binary log '",$Config{'LogBinary'},": $!\n";
	}
	return \@Logged;
}

sub AnalyzeLogs {
	my @Files=();
	my $Logged=LoadLogBin();
	for my $FileName (@{$Config{'Logs'}}) {
		if (open(LOGFILE,$FileName)) {
			while (my $Line=<LOGFILE>) {
				chomp $Line;
				for my $Logger (@{$Config{'LogStrings'}}) {
					last if $Logger->Apply($Line,\@Files,$Logged);
				}
			}
			close(LOGFILE);
		} else {
			print STDERR "Cannot open log file '$FileName': $!\n";
		}
	}
	SaveLogBin(\@Files,$Logged);
	return \@Files;
}

sub SaveLogBin {
	my ($Logging,$Logged)=@_;
	if (open(LOGBIN,'>'.$Config{'LogBinary'})) {
		binmode LOGBIN;
		print LOGBIN pack('V',scalar @$Logging+scalar @$Logged);
		foreach my $File (@$Logged) {SaveString(*LOGBIN{IO},$File->[0],$File->[1]);}
		foreach my $File (@$Logging) {SaveString(*LOGBIN{IO},$File->[0],$File->[1]);}
		close(LOGBIN);
	} else {
		print STDERR "Cannot create binary log '",$Config{'LogBinary'},": $!\n";
	}
	return \@Logged;
}

1;
