# FreqMgr 2.10 - FMgrLimit class
# Copyright (C) 2.10, Kostromitinov Pavel
#
package FMgrLimit;
sub new {
	my ($Class,$Group,$Level,$MaxTime,$DayLimit,$WeekLimit,$MonthLimit)=@_;
	$Class=ref $Class if ref $Class;
	my %FMgrLimit=('Group'=>$Group,'Level'=>$Level,'MaxTime'=>$MaxTime,
			'DayLimit'=>$DayLimit,'WeekLimit'=>$WeekLimit,'MonthLimit'=>$MonthLimit);
	return bless \%FMgrLimit,$Class;
}

sub FromLine {
	my ($Class,$String)=@_;
	if ($String=~/^\s*(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s*$/) {
		return new FMgrLimit('',0,$1,$2,$3,$4);
	}

	if ($String=~/^\s*(\d+)?(@(\S*?))?\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s*$/) {
		return new FMgrLimit((defined $3)?$3:'',(defined $1)?$1:0,$4,$5,$6,$7);
	}
	LogDie("Invalid Limit string: '$String'");
}

1;

package TMailHistory;
use FTN;
use Data::Dumper;

sub new {
	my ($Class,$Addr,$Days,$LastDate)=@_;
	$Class=ref $Class if ref $Class;
	my $Diff=(time()-$LastDate)/86400;

	if ($Diff>=1) {
		if ($Diff>29) {@$Days=();} else {splice(@$Days,-$Diff);}
	}

	unshift(@$Days,0) while @$Days<30;
	my %TMailHistory=('Addr'=>$Addr,'Days'=>$Days);
	return bless \%TMailHistory,$Class;
}

sub ThisWeek {
	my ($This)=@_;
	my $ThisWeek=0;
	for (my $I=0;$I<7;$I++) {$ThisWeek+=$This->{'Days'}->[$I];}
	return $ThisWeek;
}

sub ThisMonth {
	my ($This)=@_;
	my $ThisMonth=0;
	for (my $I=0;$I<30;$I++) {$ThisMonth+=$This->{'Days'}->[$I];}
	return $ThisMonth;
}

sub Binary {
	my ($This)=@_;
	return pack('v4v30V',
		$This->{'Addr'}->[0],
		$This->{'Addr'}->[1],
		$This->{'Addr'}->[2],
		$This->{'Addr'}->[3],
		@{$This->{'Days'}},
		time()
	);
}

1;
