# FreqMgr 2.10 - directory scanning routines
# Copyright (C) 2.10, Kostromitinov Pavel
#
package FMgrScan;
require Exporter;
@ISA=qw(Exporter);
@EXPORT=qw(ScanDirectory RecurseDirectory);

use FMgrCommon;
use FNdxArea;
use FNdxFile;
use File::Spec;
BEGIN {do 'FMgrExport.pm';}

sub ScanDirectory {
	my ($Path,$AccessLevel)=@_;
	my $Area=new FNdxArea('',$Path,$AccessLevel,'',0,0);
	$Area->{'Files'}=[];
	local *READDIR;
	return $Area unless opendir(READDIR,$Path);
	while (defined(my $FileName=readdir(READDIR))) {
		my $FullName=$Path.$FileName;
		if (-f $FullName) {
			my @Stat=stat($FullName);
			my $File=new FNdxFile($FileName,[''],0,$Stat[7],$Stat[9],$Area);
			push(@{$Area->{'Files'}},$File);
		}
	}
	closedir(READDIR);
	return $Area;
}

sub RecurseDirectory {
	my ($Path,$AccessLevel)=@_;
	my $Area=ScanDirectory($Path,$AccessLevel);
	my @Areas=($Area);
	local *READDIR;

	return \@Areas unless opendir(READDIR,$Path);
	while (defined(my $DirName=readdir(READDIR))) {
		next unless File::Spec->no_upwards($DirName);
		my $FullName=$Path.$DirName;
		if (-d $FullName) {
			push(@Areas,ScanDirectory(File::Spec->catfile($FullName,''),$AccessLevel));
		}
	}
	closedir(READDIR);
	return \@Areas;
}

1;
