# FTN-related routines
# Copyright (C) 2.10, Kostromitinov Pavel
#
package FTN;
require Exporter;
@ISA=qw(Exporter);
@EXPORT=qw(String2Address String2AddressMask AddressMask Address2String Address2StringNoPoint
		KludgeLines);

my @DefaultAddress=(2,5030,661,0,'fidonet.org');

sub String2Address {
	my $Addr=shift;
	if ($Addr=~/^(\d+):(\d+)\/(\d+)(\.(\d+))?(@(.*))?$/) {
		return ($1,$2,$3,(defined $5)?$5:0,(defined $7)?$7:'');
	} else {return undef;}
}

sub String2AddressMask {
	my $Addr=shift;
	if ($Addr=~/^(\d+|\*):(\d+|\*)\/(\d+|\*)(\.(\d+|\*))?(@(.*))?$/) {
		return ($1,$2,$3,(defined $5)?$5:0,(defined $7)?$7:'');
	} else {return undef;}
}

sub AddressMask {
	my ($Mask,$Addr)=@_;
	return (
	(($Mask->[0] eq '*')||($Addr->[0]==$Mask->[0]))&&
	(($Mask->[1] eq '*')||($Addr->[1]==$Mask->[1]))&&
	(($Mask->[2] eq '*')||($Addr->[2]==$Mask->[2]))&&
	(($Mask->[3] eq '*')||($Addr->[3]==$Mask->[3]))
	)?1:0;
}

sub Address2String {
	my ($Addr,$UseDomain)=@_;
	$UseDomain=0 unless defined $UseDomain;
	my $Str=$Addr->[0].':'.$Addr->[1].'/'.$Addr->[2].'.'.$Addr->[3];
	$Str.='@'.$Addr->[4] if $UseDomain&&($Addr->[4] ne '');
	return $Str;
}

sub Address2StringNoPoint {
	my ($Addr,$UseDomain)=@_;
	$UseDomain=0 unless defined $UseDomain;
	my $Str=$Addr->[0].':'.$Addr->[1].'/'.$Addr->[2];
	$Str.='@'.$Addr->[4] if $UseDomain&&($Addr->[4] ne '');
	return $Str;
}

sub KludgeLines {
	my ($Orig,$Dest,$UseDomain)=@_;
	$UseDomain=0 unless defined $UseDomain;
	my @Lines;
	push(@Lines,"\x01INTL ".Address2StringNoPoint($Dest).' '.Address2StringNoPoint($Orig));
	push(@Lines,"\x01FMPT ".$Orig->[3]) if ($Orig->[3]!=0);
	push(@Lines,"\x01TOPT ".$Dest->[3]) if ($Dest->[3]!=0);
	push(@Lines,"\x01MSGID ".Address2String($Orig,1).sprintf(' %08x',time()));
	if ($UseDomain||($Dest->[4] ne '')) {
		my $DomainLine="\x01DOMAIN ".
			(($Dest->[4] ne '')?$Dest->[4]:$DefaultAddress[4]).
            (($Orig->[4] ne '')?$Orig->[4]:$DefaultAddress[4]);
		push(@Lines,$DomainLine);
	}
	return @Lines;
}

1;
