# Command-line parameters parsing
# Copyright (C) 2000, Kostromitinov Pavel

package PKParams;
require Exporter;
@ISA=qw(Exporter);
@EXPORT=qw(ParseCommandLine AsSwitch);
use Carp;

# Parameters: \%SwitchParams \%StringParams
sub ParseCommandLine {
	($SwitchParams,$StringParams)=@_;
croak "Not a hash-ref passed as first parameter" if defined($SwitchParams) and ref($SwitchParams) ne 'HASH';
	croak "Not a hash-ref passed as second parameter" if defined($StringParams) and ref($StringParams) ne 'HASH';
	for ($I=0;$I<@ARGV;$I++) {
		my $FChar=substr($ARGV[$I],0,1);
		if (($FChar eq '-')||($FChar eq '/')) {
			$Param=uc(substr($ARGV[$I],1,1));
			$Value=substr($ARGV[$I],2);
			if ($Param eq $FChar) {
				if ($Value eq '') {$I++;last;} else {return $ARGV[$I];}
			}
			if (exists $SwitchParams->{$Param}) {
				$Value=AsSwitch($Value);
				return $ARGV[$I] if not defined $Value;
				$SwitchParams->{$Param}=$Value;
				next;
			}
			if (exists $StringParams->{$Param}) {
				if (ref($StringParams->{$Param}) eq 'ARRAY') {
					push(@{$StringParams->{$Param}},$Value);
				} else {
					$StringParams->{$Param}=$Value;
				}
				next;
			}
            return $ARGV[$I];
		} else {
			last;
		}
	}
	splice(@ARGV,0,$I);
	return undef;
}

sub AsSwitch {
	$Value=$_[0];
	if (($Value eq '')|($Value eq '+')||($Value eq '1')) {return 1;}
	if (($Value eq '-')|($Value eq '0')) {return 0;}
	return undef;
}

1;
